# Definition for a binary tree node.
# class TreeNode(object):
#     def __init__(self, x):
#         self.val = x
#         self.left = None
#         self.right = None

class Solution(object):
    def lowestCommonAncestor(self, root, p, q):
        """
        :type root: TreeNode
        :type p: TreeNode
        :type q: TreeNode
        :rtype: TreeNode
        """
        if (root == None):
            return None
        if ((root.val >= p.val and root.val <= q.val) or (root.val >= q.val and root.val <= p.val)):
            return root
        if (root.val < p.val and root.val < q.val):
            return self.lowestCommonAncestor(root.right, p, q)

        if (root.val > p.val and root.val > q.val):
            return self.lowestCommonAncestor(root.left, p, q)
        return None


    def lowestCommonAncestor1(self, root, p, q):
        """
        :type root: TreeNode
        :type p: TreeNode
        :type q: TreeNode
        :rtype: TreeNode
        """
        son_dic = {}

        def get_son_dic(root):
            if not root:
                return []
            else:
                son_dic[root] = [root] + get_son_dic(root.left) + get_son_dic(root.right)
                return son_dic[root]
        result = root
        while True:
            if p in son_dic[result.left] and q in son_dic[result.left]:
                result = result.left
            elif p in son_dic[result.right] and q in son_dic[result.right]:
                result = result.right
            else:
                return result

